'' *****************************
'' Radio data in
'' *****************************


CON

  CR = 13                                               ' ASCII <CR>
  LF = 10                                               ' ASCII <LF>
  serXmit   = 6                                         ' Serial Transmit on mouse
  serRecv   = 7                                         ' Serial Receive  on mouse

  
VAR  
   long gps_stack[30] 
   byte GPRMCb[68],GPGGAb[80]',PGRMZb[40]   
   long GPRMCa[20],GPGGAa[20]',PGRMZa[20]   
   long temp1,temp2

   byte gps_buff[80],Rx',cksum
   long cog,cptr,ptr,arg,j
   long Null[1]

   
OBJ
    'Init, AddPort and Start need to be called for this object from main COG

  uart :  "FullDuplexSerial_mini"

PUB start : okay

'' Starts uart object (at baud specified) in a cog
'' -- returns false if no cog available

  okay := uart.start(serRecv,serXmit,0,600)
  return cog := cognew(readRADIO,@gps_stack) + 1 

PUB readRADIO
  Null[0] := 0
  repeat
   longfill(gps_buff,20,0)
   repeat while Rx <>= "$"      ' wait for the $
     Rx := uart.rx              '    
   cptr := 0

    repeat while Rx <>= "X" 'CR       '  continue to collect data until the end of the NMEA sentence 
       Rx := uart.rx              '  get character from Rx Buffer
'     if Rx == ","
'       gps_buff[cptr++] := 0    '  If "," replace the character with 0
'     else
       gps_buff[cptr++] := Rx   '  else save the character   
   
'   if gps_buff[0] == "W"             
'     if gps_buff[1] == "D"            
'       if gps_buff[2] == "A"            
'          copy_buffer(@GPGGAb, @GPGGAa)
    exitdata
                   

pub exitdata
    return @gps_buff
                
pub copy_buffer ( buffer,args)
         bytemove(buffer,@gps_buff,cptr) '  copy received data to buffer
         ptr := buffer
         arg := 0
         repeat j from 0 to 78           ' build array of pointers
          if byte[ptr] == 0               ' to each
             if byte[ptr+1] == 0           ' record
                long[args][arg] := Null     ' in 
             else                            ' the
                long[args][arg] := ptr+1     ' data buffer
             arg++
          ptr++
          
' now we just need to return the pointer to the desired record
          
'pub altitude
'   return PGRMZa[0]

' $WDA,123.4,123,123,213 vento, angolo accelerometro x, y, z

    

pub windspeed
   return GPGGAa[0]

pub inclx
   return GPGGAa[1]
    
pub incly
   return GPGGAa[2]
     
pub inclz
   return GPGGAa[3]

pub i
   return GPGGAa[4]    